#include "Test.h"
#include "Vektor.h"
#include <iostream>
using namespace std;

/** Es wird ein Vektor erzeugt und mit dem Wert 81
gefuellt. Anschliessend wird geprueft, ob auch jedes
Element den Wert 81 hat.
*/
bool testInit() {
   Vektor v(4);
   const int wert=81;
   v.Init(wert);
   for (int i=0; i< v.GetDim(); ++i)   {
      if (v.GetDatum(i) != wert) {
         return false;
      }
   }
   return true;
}


/** Es werden zwei Vektoren erzeugt und mit 
den Werten 81 und -10 belegt. Nach Aufruf
von Add sollte der ergebnis-Vektor den
Wert 71 enthalten. 
*/
bool testPlus() {
   Vektor v1(4);
   const int wert1=81;
   v1.Init(wert1);

   Vektor v2(4);
   const int wert2= -10;
   v2.Init(wert2);

   Vektor result(4);
   v1.Plus(v2, result);

   for (int i=0; i<result.GetDim(); ++i)   {
	   if (result.GetDatum(i) != (wert1+wert2)) {
         return false;
      }
   }
   return true;
}




/** Es werden zwei Vektoren erzeugt und mit
den Werten 81 und -10 belegt. Nach Aufruf
von Add sollte der ergebnis-Vektor den
Wert 71 enthalten.
*/
bool testPlusOp() {
   Vektor v1(4);
   const int wert1 = 81;
   v1.Init(wert1);

   Vektor v2(4);
   const int wert2 = -10;
   v2.Init(wert2);

   Vektor result(4);
   result = v1 + v2;

   for (int i = 0; i < result.GetDim(); ++i) {
      if (result.GetDatum(i) != (wert1 + wert2)) {
         return false;
      }
   }
   return true;
}

bool testMinusOp() {
   Vektor v1(4);
   const int wert1 = 81;
   v1.Init(wert1);

   Vektor v2(4);
   const int wert2 = 10;
   v2.Init(wert2);

   Vektor result(4);
   result = v1 - v2; 

   for (int i = 0; i < result.GetDim(); ++i) {
      if (result.GetDatum(i) != (wert1 - wert2)) {
         return false;
      }
   }
   for (int i = 0; i < v1.GetDim(); ++i) {
      if (v1.GetDatum(i) != wert1) {
         return false;
      }
   }

   cout << "Vektor v1     ist: " << v1 << endl;
   cout << "Vektor result ist: " << result << endl;
   return true;
}


bool testPostPreInce() {
    Vektor v1(4);
    const int wert1 = 81;
    v1.Init(wert1);
    
    Vektor v2(v1++);
    for (int i = 0; i < v2.GetDim(); ++i) {
        if (v2.GetDatum(i) != wert1 ) {
            return false;
        }
    }
    for (int i = 0; i < v1.GetDim(); ++i) {
        if (v1.GetDatum(i) != wert1+1) {
            return false;
        }
    }
    Vektor v3(++v2);
    for (int i = 0; i < v3.GetDim(); ++i) {
        if (v3.GetDatum(i) != wert1+1) {
            return false;
        }
    }
    for (int i = 0; i < v2.GetDim(); ++i) {
        if (v2.GetDatum(i) != wert1 + 1) {
            return false;
        }
    }
    return true;
}




/** Es wird ein Vektor mit 4 Elementen erzeugt 
und mit dem Wert 80 gefuellt. 
Anschliessend wird die Dimension des Vektors auf 100
erhoeht und jedes Element mit 81 belegt.
Dann wird geprueft, ob auch jedes
der 100 Elemente den Wert 81 hat.
*/
bool testResize() {
   Vektor v(4);
   const int wert=81;
   v.Init(wert-1);
   v.Resize(100);
   v.Init(wert);
   for (int i=0; i< 100; ++i)   {
      if (v.GetDatum(i) != wert) {
         return false;
      }
   }
   return true;
}


void DoNothing(Vektor arg)
{

}
/** Es wird ein Vektor auf dem Stack angelegt.
Nun wird mit dem Vektor die Funktion DoNothing
aufgerufen. Der Test ist erfolgreich, wenn
DoNothing ohne Probleme wieder verlassen wird.
*/
bool testMacheNix()
{
   Vektor v(4);
   DoNothing(v);
   return true;
}

bool testZuwOp()
{
   Vektor v1(24);
   Vektor v2(14);
   Vektor v3(4);

   v3 = v2 = v1;
   v2 = v2;
   return true;
}
