#include "Vektor.h"

#include <iostream>
#include <iomanip> // wegen setw
#include <cassert> // wegen assert
using namespace std;


Vektor::Vektor(int dim) {
	dimension = dim;
	daten = new V_BaseType[dim];
}

Vektor::~Vektor(){
	delete[] daten;
	daten = nullptr;
}


void Vektor::Init(V_BaseType wert) {
   for (int i=0; i<this->dimension; ++i){
      daten[i] = wert;
   }
}

void Vektor::Plus(const Vektor& v2, Vektor& erg) {
   assert(dimension == v2.dimension);
   assert(erg.dimension == v2.dimension);
   for (int i=0; i<dimension; ++i){
      erg.daten[i] = daten[i] + v2.daten[i];
   }
}



Vektor operator+(const Vektor& v1, const Vektor& v2) {
   assert(v1.dimension == v2.dimension);
   Vektor erg(v1.dimension);
   for (int i = 0; i < v1.dimension; ++i) {
      erg.daten[i] = v1.daten[i] + v2.daten[i];
   }
   return erg;
}

Vektor Vektor::operator-(const Vektor& v2) {
   assert(this->dimension == v2.dimension);
   Vektor erg(dimension);
   for (int i = 0; i < this->dimension; ++i) {
      erg.daten[i] = daten[i] - v2.daten[i];
   }
   return erg;
}

void Vektor::Print() const {
   for (int i=0; i<dimension; ++i){
      cout << setw(4) << daten[i];
   }
}

void Vektor::Resize(int dim) {
	delete[] daten;
	daten = new V_BaseType[dim];
	dimension = dim;

}

typedef int V_BaseType;
void Vektor::ResizeCopy(int dim) {
   if (dim > dimension) {
      if (dimension > 0) {
         V_BaseType* tmp = new V_BaseType[dim];
         for (int j = 0; j < dimension; ++j) {
            tmp[j] = daten[j];
         }
         delete[] daten;
         daten = tmp;
         dimension = dim;
      }
   }
}



Vektor::Vektor(const Vektor& v2) {
   dimension = v2.dimension;
   daten = new V_BaseType[dimension];
   for (int i = 0; i < dimension; ++i) {
      daten[i] = v2.daten[i];
   }
}


Vektor& Vektor::operator=(const Vektor& v2) {
   if (this != &v2) {
      delete[] daten;
      dimension = v2.dimension;
      daten = new V_BaseType[dimension];
      for (int i = 0; i < dimension; ++i) {
         daten[i] = v2.daten[i];
      }
   }
   return *this;
}


Vektor& Vektor::operator++()   
/* Pre - Increment
  plus 1 machen
  return *this;
*/
{
    for (int i = 0; i < dimension; ++i) {
        ++daten[i];
    }
    return *this;
}



Vektor Vektor::operator++(int)
/* Post - Increment
      Vektor temp = *this;
      plus 1 machen
      return temp;
*/
{
    Vektor temp(*this);
    for (int i = 0; i < dimension; ++i) {
        ++daten[i];
    }
    return temp;
}



// Die Elemente werden durch " # " getrennt voneinander 
// ausgegeben. Man htte auch Print aufrufen knnen
std::ostream& operator<<(std::ostream& str, const Vektor& v) {
   string trenner = "";
   for (int i = 0; i < v.GetDim(); i++) {
      str << trenner << v.daten[i];
      trenner = " # ";
   }
   return str;
}





